/* Generated by Scriptol */

const fs=require('fs');
const scriptol=require('scriptol');
// (c) 2007-2017 www.scriptol.com
// Based on PHP FTP Synchronizer by Kim Haskell & Denis Sureau
// Free under the GNU GPL 3 License.
// Scriptol sources are compiled with the Scriptol-JavaScript compiler (www.scriptol.org).
//
// The synchronizer updates a website from a local directory.
// Optionally links are verified by the builtin link checker.
// Read the manual for details of use.
eval(fs.readFileSync(__dirname + '/path.js')+'');
eval(fs.readFileSync(__dirname + '/libftp.js')+'');
var CHECKMODE=false;

var QUIET=false;

var BACKUP=false;

var ANYFILES=false;

var VERBOSE=false;

var DEBUG=false;

var server="";

var user="";

var pass="";

var root="";

var remotedir="";

var params=[];

var backdir="";

var temporary="temporary-file.000.tmp";

var website="";

var COUNTER=0;

var FTPCOUNT=0;

var ERRCOUNT=0;

var falsecounter=0;

var problem=0;

var OPTIONS={};

var FilesArray=[];

function usage()
{
   console.log();
   console.log("JS FTP Synchronizer 1.1 - (c) 2007-2017 Scriptol.com");
   console.log("----------------------------------------------------");
   console.log("Syntax:");
   console.log("  solj sync [options & parameters] source");
   console.log("Options:");
   console.log("  -t test mode, display only and do not upload.");
   console.log("  -a upload all files, restore the full site.");
   console.log("  -s speed up, do not check links in pages.");
   console.log("  -v verbose, display more infos.");
   console.log("  -q quiet, display nothing.");
   console.log("Parameters:");
   console.log("  -wwebsite url.");
   console.log("  -ppassword.");
   console.log("  -llogin.");
   console.log("  -fftpadr ftp address in the form ftp.domain.tld (like ftp.scriptol.com).");
   console.log("  -ddirectory remote directory where to upload the files.");
   console.log("  -bbackup, defining a backup directory.");
   console.log("  source: a directory to backup");
   console.log("You will be prompted for each required parameter if omitted.");
   console.log("See manual for more.");
   process.exit(0);
   return;
}

function backError(b)
{
   console.log("Can't write on backup "+b+", check device or path and try again...");
   process.exit(0);
   return;
}

function checkBackup(bpath)
{
   var tempfile=Path.merge(bpath,'ftpsynxyz.$$$');

   var f={};

   $error=(f=scriptol.fopen(tempfile,"w"));
   if($error===false) {
      backError(bpath);
   }
   var saved=fs.appendFileSync(f,"ftp sync check");

   scriptol.fclose(f);
   fs.unlinkSync(tempfile);
   if(saved===0) {
      backError(bpath);
   }
   return;
}

function cbFileSent(err,data)
{
   if(err) {
      console.log(err);
      return;
   }
   if(VERBOSE) {
      console.log(data);
   }
   return;
}

function authBack(err,res)
{
   if(err) {
      console.log(err);
      return;
   }
   if(VERBOSE) {
      console.log(res);
   }
   return;
}

// Check if file modified
function backupIdentical(locfile,bakfile)
{
   if(DEBUG===true) {
      console.log("Comparing "+locfile+" and local "+bakfile);
   }
   if(!fs.existsSync(bakfile)) {
      return false;
   }
   if(scriptol.filesize(locfile)!=scriptol.filesize(bakfile)) {
      return false;
   }
   if(scriptol.filemtime(locfile)===scriptol.filemtime(bakfile)) {
      return true;
   }
   var x=[];

   var y=[];

   scriptol.arrayLoad(x,locfile);
   scriptol.arrayLoad(y,bakfile);
   return scriptol.aCompare(x,y,"=");
}

// synchronize
async function synchro(locdir,bdir,hostdir)
{
   if(VERBOSE) {
      console.log("Entering "+locdir);
   }
   var content=fs.readdirSync(locdir);

   var src="";

   var bfile="";

   var rmt="";

   var name="";

   if(scriptol.empty(content)) {
      return;
   }
   for(name in content) {
      name=content[name];
      if(name.slice(0,11)==="javascript:") {
         continue;
      }
      if(name.charAt(0)==="/") {
         src=Path.merge(root,name);
      }      
      else {
         src=Path.merge(locdir,name);
      }
      if(scriptol.filetype(src)==="file") {
         rmt=Path.merge(hostdir,name);
         if(ANYFILES===true) {
            bfile=Path.merge(bdir,name);
            await new Promise(function (resolve) { resolve(fileCopy(src,rmt,hostdir,bfile,bdir));});
            var fgroup={"lfile":src,"rfile":rmt,"hdir":hostdir};

            FilesArray.push(fgroup);
            continue;
         }
         if(name.charAt(0)===".") {
            if(!QUIET) {
               console.log(name+' '+"skipped");
            }
            problem+=1;
            continue;
         }
         if(BACKUP===true) {
            bfile=Path.merge(bdir,name);
            var samecont=backupIdentical(src,bfile);

            if(samecont) {
               continue;
            }
         }
         await new Promise(function (resolve) { resolve(fileCopy(src,rmt,hostdir,bfile,bdir));});
         var fgroup={"lfile":src,"rfile":rmt,"hdir":hostdir};

         FilesArray.push(fgroup);
      }
   }
   for(name in content) {
      name=content[name];
      if(name.charAt(0)==='.') {
         continue;
      }
      src=Path.merge(locdir,name);
      if(scriptol.filetype(src)==="dir") {
         synchro(src,Path.merge(bdir,name),Path.merge(hostdir,name));
      }
   }
   return;
}

// Parsing command line parameters
function processCommand(argnum,argv)
{
   var daystring="";

   var opt="";

   if(argnum<2) {
      usage();
   }
   for(var param in argv) {
      param=String(argv[param]);
      if(param.length>1) {
         opt=param.slice(0,2);
      }      
      else {
         usage();
      }
      if(opt==="-t") {
         CHECKMODE=true;
         continue;
      }
      if(opt==="-a") {
         ANYFILES=true;
         continue;
      }
      if(opt==="-p") {
         pass=param.slice(2);
         if(pass==="") {
            scriptol.die("-p must be followed by the password.");
         }
         continue;
      }
      if(opt==="-l") {
         user=param.slice(2);
         if(user==="") {
            scriptol.die("-l must be followed by the login.");
         }
         continue;
      }
      if(opt==="-f") {
         server=param.slice(2);
         if(server==="") {
            scriptol.die("-f must be followed by the ftp address.");
         }
         continue;
      }
      if(opt==="-d") {
         remotedir=param.slice(2);
         if(remotedir==="") {
            scriptol.die("-d requires a sub-directory.");
         }
         continue;
      }
      if(opt==="-b") {
         backdir=param.slice(2);
         if(backdir==="") {
            scriptol.die("-b requires a directory.");
         }
         BACKUP=true;
         continue;
      }
      if(opt==="-w") {
         website=param.slice(2);
         if(website==="") {
            scriptol.die("-w must be followed by the site url.");
         }
         continue;
      }
      if(param.slice(0,4)==="ftp.") {
         server=param;
         continue;
      }
      if(opt==="-v") {
         VERBOSE=true;
         continue;
      }
      if(opt==="-q") {
         QUIET=true;
         continue;
      }
      if(opt==="-~") {
         DEBUG=true;
         continue;
      }
      if(param.charAt(0)==="-") {
         console.log("Unknown command "+param);
         usage();
      }
      if(root==="") {
         root=param;
         continue;
      }
      console.log("Unknown command "+param);
      usage();
   }
   if(BACKUP===true) {
      checkBackup(backdir);
   }
   if(server==="") {
            server=scriptol.input("FTP location: ");
   }
   if(server==="") {
      process.exit(0);
   }
   if(root==="") {
            root=scriptol.input("Directory to send: ");
   }
   if(root==="") {
      process.exit(0);
   }
   if(user==="") {
            user=scriptol.input("Login: ");
   }
   if(user==="") {
      process.exit(0);
   }
   if(pass==="") {
            pass=scriptol.input("Password: ");
   }
   if(pass==="") {
      process.exit(0);
   }
   return;
}

function saybye(err,data)
{
   if(err) {
      console.log(err);
      return;
   }
   console.log("Done!");
   return;
}

function dispCount()
{
   process.stdout.write(String(COUNTER)+" file"+(COUNTER>1?"s":"")+" copied");
   if(CHECKMODE) {
      if(falsecounter>0) {
         process.stdout.write(", "+String(falsecounter)+" file"+(falsecounter>1?"s":"")+" to update");
      }      
      else {
         process.stdout.write(", nothing to update");
      }
   }
   console.log(".");
   return;
}

function main(argc,argv)
{
   var x=argv.slice(1);

   processCommand(argc,x.slice());
   problem=0;
   if(!QUIET) {
      if(VERBOSE===true) {
         console.log("Verbose mode enabled");
      }
      if(DEBUG===true) {
         console.log("Debug mode enabled");
      }
      console.log("Source directory: "+root);
      console.log("Remote directory:"+' '+remotedir);
      if(BACKUP===true) {
         console.log("Backup location: "+backdir);
      }
      if(ANYFILES===true) {
         console.log("Website will be restored");
      }
   }
   OPTIONS={"host":server,"port":21,"user":user,"pass":pass,"debugMode":true};
   console.log("Synchronizing "+root+" on "+server);
   synchro(root,backdir,remotedir);
   beforeExit(dispCount);
   return 0;
}

main(process.argv.length-1,process.argv.slice(1));


/* End */
